## eckit 1.11.6

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6 FATAL_ERROR )

project( eckit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 3.0 )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

### dependencies and options

ecbuild_add_option( FEATURE BUILD_TOOLS
                    DEFAULT ON
                    DESCRIPTION "Build the command line tools" )

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()
### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    REQUIRED_PACKAGES "LEXYACC" "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    REQUIRED_PACKAGES "LEXYACC" )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES AEC )

### LAPACK

if( ECKIT_HAVE_MKL )
    set( ECKIT_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1)

ecbuild_add_option( FEATURE SSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

### xxHash

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "Use xxHash for non-crypto hashing in data integrity checks"
                    REQUIRED_PACKAGES "xxHash QUIET" )

if( XXHASH_FOUND )
  ecbuild_info("xxHash -- libs [${XXHASH_LIBRARIES}] incs [${XXHASH_INCLUDE_DIRS}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES CURL )

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### LibRsync

ecbuild_add_option( FEATURE RSYNC
                    DEFAULT OFF
                    DESCRIPTION "librsync implementation of the rsync algorithm"
                    REQUIRED_PACKAGES LibRsync )
if( HAVE_RSYNC )
  set( LIBRSYNC_LIBRARIES rsync )
endif()

### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### async io support

find_package( AIO )
ecbuild_add_option( FEATURE AIO
                    DEFAULT ON
                    CONDITION ${AIO_FOUND}
                    DESCRIPTION "support for asynchronous IO")

### c math library, needed when including "math.h"

find_package( CMath )

### realtime library implements shm_open on Linux
if( CMAKE_SYSTEM_NAME MATCHES "Linux" )
    find_package( Realtime )
    if( REALTIME_FOUND ) # check that aio needs realtime
        set( RT_LIBRARIES ${RT_LIB} )
    endif()
else()
  set( RT_LIBRARIES "" )
endif()

###############################################################################
# checks

# check thread library is pthreads
if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${THREADS_LIBRARIES}]" )
endif()

############################################################################################
# export package info

set( ECKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ECKIT_LIBRARIES      eckit eckit_geometry eckit_linalg eckit_maths eckit_mpi eckit_web )

if( HAVE_ECKIT_CMD)
  list( APPEND ECKIT_LIBRARIES eckit_cmd )
endif()

if( HAVE_EXPERIMENTAL )

  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/experimental )

endif()

get_directory_property( ECKIT_DEFINITIONS COMPILE_DEFINITIONS )

############################################################################################
# sources

ecbuild_find_project_files()

include_directories( ${ECKIT_INCLUDE_DIRS} )
if( HAVE_EIGEN )
    include_directories( ${EIGEN3_INCLUDE_DIR} )
endif()

add_subdirectory( bamboo )
add_subdirectory( doc )
add_subdirectory( src )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README.md NOTICE LICENSE INSTALL ChangeLog COPYING )

############################################################################################
# finalize

foreach( _lib ${ECKIT_LIBRARIES} )
  if( TARGET ${_lib} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
  endif()
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== src/eckit/CMakeLists.txt ===
### endianess

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
        set( ECKIT_BIG_ENDIAN    1 )
        set( ECKIT_LITTLE_ENDIAN 0 )
else()
        set( ECKIT_BIG_ENDIAN    0 )
        set( ECKIT_LITTLE_ENDIAN 1 )
endif()

set( ECKIT_BIG_ENDIAN    ${ECKIT_BIG_ENDIAN}    )
set( ECKIT_LITTLE_ENDIAN ${ECKIT_LITTLE_ENDIAN} )

### check support for DL library

check_include_files( dlfcn.h  ECKIT_HAVE_DLFCN_H )

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        ECKIT_HAVE_DLADDR )
cmake_pop_check_state()

### system headers and symbols tests for eckit config headers

check_symbol_exists( MAP_ANONYMOUS "sys/mman.h"  ECKIT_HAVE_MAP_ANONYMOUS )
check_symbol_exists( MAP_ANON      "sys/mman.h"  ECKIT_HAVE_MAP_ANON )
check_symbol_exists( funopen       "stdio.h"     ECKIT_HAVE_FUNOPEN )
check_symbol_exists( fsync         "unistd.h"    ECKIT_HAVE_FSYNC)
check_symbol_exists( fdatasync     "unistd.h"    ECKIT_HAVE_FDATASYNC)
check_symbol_exists( F_FULLFSYNC   "fcntl.h"     ECKIT_HAVE_F_FULLFSYNC)
check_symbol_exists( fmemopen      "stdio.h"     ECKIT_HAVE_FMEMOPEN )

check_c_source_compiles( "#define _GNU_SOURCE\n#include <stdio.h>\nint main(){ void* cookie; const char* mode; cookie_io_functions_t iof; FILE* fopencookie(void *cookie, const char *mode, cookie_io_functions_t iof); }"
    ECKIT_HAVE_FOPENCOOKIE )

check_c_source_compiles( "#include <unistd.h>\n#include <execinfo.h>\n int main(){ void ** buffer; int i = backtrace(buffer, 256); }\n"
    ECKIT_HAVE_EXECINFO_BACKTRACE )

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    ECKIT_HAVE_CXXABI_H )

check_c_source_compiles( "#include <time.h>\nint main(){ time_t now; time(&now); struct tm t; gmtime_r(&now,&t); }\n"
    ECKIT_HAVE_GMTIME_R )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; struct dirent **result; int i = readdir_r(dirp, entry, result); }\n"
    ECKIT_HAVE_READDIR_R )

check_c_source_compiles( "#include <sys/types.h>\n#include <dirent.h>\nint main(){ DIR *dirp; int i = dirfd(dirp); }\n"
    ECKIT_HAVE_DIRFD )

check_c_source_compiles( "#include <dirent.h>\nint main(){ DIR *dirp; struct dirent *entry; if(entry->d_type) { dirp = 0; } }\n"
    ECKIT_HAVE_DIRENT_D_TYPE )

check_cxx_source_compiles( "int main() { __int128 i = 0; return 0;}"
    ECKIT_HAVE_CXX_INT_128 )

### config headers

ecbuild_generate_config_headers( DESTINATION ${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_config.h.in   eckit_config.h  )
configure_file( eckit_version.h.in  eckit_version.h )

install(FILES
			${CMAKE_CURRENT_BINARY_DIR}/eckit_config.h
			${CMAKE_CURRENT_BINARY_DIR}/eckit_version.h
		DESTINATION
			${INSTALL_INCLUDE_DIR}/eckit )

configure_file( eckit_version.cc.in  eckit_version.cc )

### eckit sources

list( APPEND eckit_srcs eckit.h deprecated.h eckit_version.cc )

list( APPEND eckit_container_srcs

container/BSPTree.h
container/BTree.cc
container/BTree.h
container/BloomFilter.cc
container/BloomFilter.h
container/Cache.h
container/CacheLRU.cc
container/CacheLRU.h
container/CacheManager.cc
container/CacheManager.h
container/ClassExtent.h
container/DenseMap.h
container/DenseSet.h
container/KDMapped.cc
container/KDMapped.h
container/KDMemory.h
container/KDTree.h
container/MappedArray.cc
container/MappedArray.h
container/Queue.h
container/Recycler.h
container/SharedMemArray.cc
container/SharedMemArray.h
container/StatCollector.h
container/Trie.cc
container/Trie.h
container/bsptree/BSPHyperPlane.h
container/bsptree/BSPNode.cc
container/bsptree/BSPNode.h
container/kdtree/KDNode.cc
container/kdtree/KDNode.cc
container/kdtree/KDNode.h
container/sptree/SPIterator.h
container/sptree/SPMetadata.h
container/sptree/SPNode.h
container/sptree/SPNodeInfo.h
container/sptree/SPNodeQueue.h
container/sptree/SPTree.h
container/sptree/SPValue.h
)

list( APPEND eckit_io_srcs
io/AsyncHandle.cc
io/AsyncHandle.h
io/AIOHandle.cc
io/AIOHandle.h
io/AutoCloser.h
io/Base64.cc
io/Base64.h
io/BitIO.cc
io/BitIO.h
io/Buffer.cc
io/Buffer.h
io/BufferCache.cc
io/BufferCache.h
io/BufferedHandle.cc
io/BufferedHandle.h
io/CircularBuffer.cc
io/CircularBuffer.h
io/CommandStream.cc
io/CommandStream.h
io/Compress.cc
io/Compress.h
io/DataBlob.cc
io/DataBlob.h
io/DataHandle.cc
io/DataHandle.h
io/DblBuffer.cc
io/DblBuffer.h
io/EasyCURL.cc
io/EasyCURL.h
io/EmptyHandle.cc
io/EmptyHandle.h
io/FDataSync.cc
io/FDataSync.h
io/FTPHandle.cc
io/FTPHandle.h
io/FileBase.cc
io/FileBase.h
io/FileDescHandle.cc
io/FileDescHandle.h
io/FileHandle.cc
io/FileHandle.h
io/MMappedFileHandle.cc
io/MMappedFileHandle.h
io/FileLock.cc
io/FileLock.h
io/FileLocker.cc
io/FileLocker.h
io/FilePool.cc
io/FilePool.h
io/FileHandle.cc
io/FileHandle.h
io/HandleBuf.cc
io/HandleBuf.h
io/HandleHolder.cc
io/HandleHolder.h
io/Length.cc
io/Length.h
io/MarsFSHandle.cc
io/MarsFSHandle.h
io/MemoryHandle.cc
io/MemoryHandle.h
io/MoverTransfer.cc
io/MoverTransfer.h
io/MultiHandle.cc
io/MultiHandle.h
io/Offset.cc
io/Offset.h
io/PartFileHandle.cc
io/PartFileHandle.h
io/PartHandle.cc
io/PartHandle.h
io/PipeHandle.cc
io/PipeHandle.h
io/Pipeline.cc
io/Pipeline.h
io/PooledFile.cc
io/PooledFile.h
io/PooledHandle.cc
io/PooledHandle.h
io/PooledFileDescriptor.cc
io/PooledFileDescriptor.h
io/RawFileHandle.cc
io/RawFileHandle.h
io/ResizableBuffer.cc
io/ResizableBuffer.h
io/Select.cc
io/Select.h
io/SharedBuffer.cc
io/SharedBuffer.h
io/SharedHandle.cc
io/SharedHandle.h
io/SockBuf.cc
io/SockBuf.h
io/StatsHandle.cc
io/StatsHandle.h
io/StdFile.cc
io/StdFile.h
io/StdFileHandle.cc
io/StdFileHandle.h
io/StdPipe.cc
io/StdPipe.h
io/StdioBuf.cc
io/StdioBuf.h
io/TCPHandle.cc
io/TCPHandle.h
io/TCPSocketHandle.cc
io/TCPSocketHandle.h
io/TeeHandle.cc
io/TeeHandle.h
io/TransferWatcher.cc
io/TransferWatcher.h
io/URLHandle.cc
io/URLHandle.h
io/cluster/ClusterDisks.cc
io/cluster/ClusterDisks.h
io/cluster/ClusterNode.cc
io/cluster/ClusterNode.h
io/cluster/ClusterNodes.cc
io/cluster/ClusterNodes.h
io/cluster/NodeInfo.cc
io/cluster/NodeInfo.h
)


if(HAVE_RADOS)
list( APPEND eckit_io_srcs
io/rados/RadosHandle.cc
io/rados/RadosHandle.h
io/rados/RadosCluster.h
io/rados/RadosCluster.cc
io/rados/RadosReadHandle.cc
io/rados/RadosReadHandle.h
io/rados/RadosWriteHandle.cc
io/rados/RadosWriteHandle.h
io/rados/RadosObject.h
io/rados/RadosObject.cc
io/rados/RadosAttributes.h
io/rados/RadosAttributes.cc
)
endif()

list( APPEND eckit_filesystem_srcs
filesystem/BasePathName.cc
filesystem/BasePathName.h
filesystem/BasePathNameT.cc
filesystem/BasePathNameT.h
filesystem/FileMode.cc
filesystem/FileMode.h
filesystem/FileSpace.cc
filesystem/FileSpace.h
filesystem/FileSpaceStrategies.cc
filesystem/FileSpaceStrategies.h
filesystem/FileSystem.cc
filesystem/FileSystem.h
filesystem/FileSystemSize.h
filesystem/LocalPathName.cc
filesystem/LocalPathName.h
filesystem/PathExpander.cc
filesystem/PathExpander.h
filesystem/PathName.cc
filesystem/PathName.h
filesystem/TempFile.cc
filesystem/TempFile.h
filesystem/TmpDir.cc
filesystem/TmpDir.h
filesystem/TmpFile.cc
filesystem/TmpFile.h
filesystem/URI.cc
filesystem/URI.h
filesystem/URIManager.cc
filesystem/URIManager.h
filesystem/marsfs/MarsFSClient.cc
filesystem/marsfs/MarsFSClient.h
filesystem/marsfs/MarsFSFile.cc
filesystem/marsfs/MarsFSFile.h
filesystem/marsfs/MarsFSPath.cc
filesystem/marsfs/MarsFSPath.h
)

list( APPEND eckit_thread_srcs
    thread/AutoLock.h
    thread/Mutex.cc
    thread/Mutex.h
    thread/MutexCond.cc
    thread/MutexCond.h
    thread/Once.h
    thread/StaticMutex.cc
    thread/StaticMutex.h
    thread/Thread.cc
    thread/Thread.h
    thread/ThreadControler.cc
    thread/ThreadControler.h
    thread/ThreadPool.cc
    thread/ThreadPool.h
    thread/ThreadSingleton.h
)

list( APPEND eckit_config_srcs
config/Configurable.cc
config/Configurable.h
config/Configuration.cc
config/Configuration.h
config/Configured.cc
config/Configured.h
config/EtcTable.cc
config/EtcTable.h
config/JSONConfiguration.h
config/LibEcKit.cc
config/LibEcKit.h
config/LocalConfiguration.cc
config/LocalConfiguration.h
config/Parametrisation.cc
config/Parametrisation.h
config/Resource.h
config/ResourceBase.cc
config/ResourceBase.h
config/ResourceMgr.cc
config/ResourceMgr.h
config/YAMLConfiguration.cc
config/YAMLConfiguration.h
)

list( APPEND eckit_runtime_srcs
runtime/Application.cc
runtime/Application.h
runtime/Dispatcher.h
runtime/Library.cc
runtime/Library.h
runtime/Main.cc
runtime/Main.h
runtime/Monitor.cc
runtime/Monitor.h
runtime/Monitorable.cc
runtime/Monitorable.h
runtime/Pipe.h
runtime/PipeApplication.cc
runtime/PipeApplication.h
runtime/PipeHandler.cc
runtime/PipeHandler.h
runtime/ProcessControler.cc
runtime/ProcessControler.h
runtime/ProducerConsumer.h
runtime/Telemetry.cc
runtime/Telemetry.h
runtime/SessionID.cc
runtime/SessionID.h
runtime/Task.cc
runtime/Task.h
runtime/TaskID.h
runtime/TaskInfo.cc
runtime/TaskInfo.h
runtime/Tool.cc
runtime/Tool.h
)

list( APPEND eckit_log_srcs
log/BigNum.cc
log/BigNum.h
log/Bytes.cc
log/Bytes.h
log/CallbackTarget.cc
log/CallbackTarget.h
log/Channel.cc
log/Channel.h
log/ChannelBuffer.cc
log/ChannelBuffer.h
log/CodeLocation.cc
log/CodeLocation.h
log/Colour.cc
log/Colour.h
log/ColouringTarget.cc
log/ColouringTarget.h
log/ETA.cc
log/ETA.h
log/FileTarget.cc
log/FileTarget.h
log/IndentTarget.cc
log/IndentTarget.h
log/JSON.cc
log/JSON.h
log/LineBasedTarget.cc
log/LineBasedTarget.h
log/Log.cc
log/Log.h
log/LogTarget.cc
log/LogTarget.h
log/MessageTarget.cc
log/MessageTarget.h
log/MonitorTarget.cc
log/MonitorTarget.h
log/Number.cc
log/Number.h
log/OStreamTarget.cc
log/OStreamTarget.h
log/Plural.h
log/PrefixTarget.cc
log/PrefixTarget.h
log/Progress.cc
log/Progress.h
log/ProgressTimer.cc
log/ProgressTimer.h
log/ResourceUsage.cc
log/ResourceUsage.h
log/RotationTarget.cc
log/RotationTarget.h
log/SavedStatus.cc
log/SavedStatus.h
log/Seconds.cc
log/Seconds.h
log/Statistics.cc
log/Statistics.h
log/StatusTarget.cc
log/StatusTarget.h
log/SysLog.cc
log/SysLog.h
log/TeeTarget.cc
log/TeeTarget.h
log/TimeStamp.cc
log/TimeStamp.h
log/TimeStampTarget.cc
log/TimeStampTarget.h
log/Timer.cc
log/Timer.h
log/TraceTimer.h
log/UserChannel.cc
log/UserChannel.h
log/WrapperTarget.cc
log/WrapperTarget.h
)

list( APPEND eckit_exception_srcs
exception/Exceptions.cc
exception/Exceptions.h
)

list( APPEND eckit_types_srcs
types/ClimateDate.cc
types/ClimateDate.h
types/Coord.cc
types/Coord.h
types/Date.cc
types/Date.h
types/DateTime.cc
types/DateTime.h
types/DayOfYear.cc
types/DayOfYear.h
types/Double.cc
types/Double.h
types/FixedString.h
types/FloatCompare.cc
types/FloatCompare.h
types/Fraction.cc
types/Fraction.h
types/Grid.cc
types/Grid.h
types/Metadata.cc
types/Metadata.h
types/Month.cc
types/Month.h
types/Time.cc
types/Time.h
types/TimeInterval.cc
types/TimeInterval.h
types/Types.cc
types/Types.h
types/UUID.cc
types/UUID.h
types/VerifyingDate.cc
types/VerifyingDate.h
)

list( APPEND eckit_parser_srcs
parser/CSVParser.cc
parser/CSVParser.h
parser/JSON.h
parser/JSONDataBlob.cc
parser/JSONDataBlob.h
parser/JSONMetadata.cc
parser/JSONMetadata.h
parser/JSONParser.cc
parser/JSONParser.h
parser/ObjectParser.cc
parser/ObjectParser.h
parser/StreamParser.cc
parser/StreamParser.h
parser/YAMLParser.cc
parser/YAMLParser.h
)

list( APPEND eckit_value_srcs
value/BoolContent.cc
value/BoolContent.h
value/CompositeParams.cc
value/CompositeParams.h
value/Content.cc
value/Content.h
value/DateContent.cc
value/DateContent.h
value/DateTimeContent.cc
value/DateTimeContent.h
value/DispatchParams.h
value/DoubleContent.cc
value/DoubleContent.h
value/Expression.h
value/ListContent.cc
value/ListContent.h
value/MapContent.cc
value/MapContent.h
value/NilContent.cc
value/NilContent.h
value/NumberContent.cc
value/NumberContent.h
value/OrderedMapContent.cc
value/OrderedMapContent.h
value/Params.cc
value/Params.h
value/Properties.cc
value/Properties.h

=== tests/filesystem/CMakeLists.txt ===
# aio system calls are know to fail on the Cray
# see https://sourceware.org/bugzilla/show_bug.cgi?id=11787

option( ENABLE_ECKIT-352 "Control if ECKIT-352 tests should be enabled" ON )

ecbuild_add_test( TARGET      eckit_test_filesystem_aiohandle
                  CONDITION   NOT DEFINED ENV{CRAYOS_VERSION} AND ${HAVE_AIO}
                  SOURCES     test_aiohandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_asynchandle
                  SOURCES     test_asynchandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_atomic_file_update
                  SOURCES     test_atomic_file_update.cc
                  LIBS        eckit )


ecbuild_add_test( TARGET      eckit_test_filesystem_localpathname
                  SOURCES     test_localpathname.cc
                  LIBS        eckit
                  CONDITION   ENABLE_ECKIT-352 )


ecbuild_add_test( TARGET      eckit_test_filesystem_restarthandle
                  SOURCES     test_restarthandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_pathexpander
                  SOURCES     test_pathexpander.cc
                  ENVIRONMENT "CURRENT_TEST_DIR=${CMAKE_CURRENT_BINARY_DIR}"
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_filemode
                  SOURCES     test_filemode.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_filesystem_uri
                  SOURCES     test_uri.cc
                  LIBS        eckit )

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tmp/foo)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/2)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/foo/2/1)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/bar)
file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/testdir/baz)

=== tests/io/CMakeLists.txt ===
### test data files
list( APPEND test_data_files
t.grib
)

if(HAVE_EXTRA_TESTS)
    ecbuild_get_test_multidata( TARGET get_eckit_io_test_data
                                NAMES ${test_data_files}
                                NOCHECK )
endif()

ecbuild_add_test( TARGET   eckit_test_filepool
                  SOURCES  test_filepool.cc
                  LIBS     eckit )

ecbuild_add_test( TARGET  eckit_test_datablob
                  SOURCES test_datablob.cc
                  LIBS    eckit )

ecbuild_add_test( TARGET  eckit_test_urlhandle
                  SOURCES test_urlhandle.cc
                  CONDITION ECKIT_HAVE_CURL AND OFF
                  LIBS    eckit )

ecbuild_add_test( TARGET  eckit_test_circularbuffer
                  SOURCES test_circularbuffer.cc
                  LIBS    eckit )

ecbuild_add_test( TARGET      eckit_test_compress
                  SOURCES     test_compress.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_bitio
                  SOURCES     test_bitio.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_base64
                  SOURCES     test_base64.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_multihandle
                  SOURCES     test_multihandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_pooledfile
                  SOURCES     test_pooledfile.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_pooledhandle
                  SOURCES     test_pooledhandle.cc
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_test_radoshandle
                  SOURCES     test_radoshandle.cc
                  CONDITION   HAVE_RADOS
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  LIBS        eckit )

ecbuild_add_test( TARGET      eckit_rados-performance
                  SOURCES     rados-performance.cc
                  CONDITION   (HAVE_EXTRA_TESTS AND HAVE_RADOS)
                  INCLUDES    ${RADOS_INCLUDE_DIRS}
                  TEST_DEPENDS get_eckit_io_test_data
                  LIBS        eckit )

=== tests/mpi/CMakeLists.txt ===
ecbuild_add_test(
    TARGET      eckit_test_mpi
    SOURCES     eckit_test_mpi.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

 ecbuild_add_test(
    TARGET      eckit_test_mpi_addcomm
    SOURCES     eckit_test_mpi_addcomm.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

ecbuild_add_test(
    TARGET      eckit_test_mpi_splitcomm
    SOURCES     eckit_test_mpi_splitcomm.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

ecbuild_add_test(
    TARGET      eckit_test_mpi_objserialisation
    SOURCES     eckit_test_mpi_objserialisation.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

ecbuild_add_test(
    TARGET      eckit_test_mpi_internal_access
    SOURCES     eckit_test_mpi_internal_access.cc
    CONDITION   HAVE_MPI
    LIBS eckit_mpi
    MPI 4
)

=== src/eckit/sql/CMakeLists.txt ===
list( APPEND eckit_sql_lib_srcs

#SQLMATCHSubquerySession.h
#SQLMATCHSubquerySession.cc
#SQLMATCHSubquerySessionOutput.h
#SQLMATCHSubquerySessionOutput.cc
Environment.cc
Environment.h
SQLBitColumn.cc
SQLBitColumn.h
SQLColumn.cc
SQLColumn.h
SQLDatabase.cc
SQLDatabase.h
SQLDistinctOutput.cc
SQLDistinctOutput.h
SQLOrderOutput.cc
SQLOrderOutput.h
SQLOutput.cc
SQLOutput.h
SQLOutputConfig.cc
SQLOutputConfig.h
SQLParser.cc
SQLParser.h
SelectOneTable.cc
SelectOneTable.h
SQLSelect.cc
SQLSelect.h
SQLSelectFactory.cc
SQLSelectFactory.h
SQLSession.cc
SQLSession.h
SQLSimpleOutput.cc
SQLSimpleOutput.h
SQLStatement.cc
SQLStatement.h
SQLTable.cc
SQLTable.h
SQLTableFactory.cc
SQLTableFactory.h
SQLTypedefs.h

SchemaAnalyzer.cc
SchemaAnalyzer.h
SchemaComponents.cc
SchemaComponents.h

expression/BitColumnExpression.cc
expression/BitColumnExpression.h
expression/ColumnExpression.cc
expression/ColumnExpression.h
expression/ConstantExpression.cc
expression/ConstantExpression.h
expression/NumberExpression.cc
expression/NumberExpression.h
expression/ParameterExpression.cc
expression/ParameterExpression.h
expression/StringExpression.cc
expression/StringExpression.h
expression/SQLExpression.cc
expression/SQLExpression.h
expression/SQLExpressions.cc
expression/SQLExpressions.h
expression/ShiftedColumnExpression.cc
expression/ShiftedColumnExpression.h
expression/SQLExpressionEvaluated.cc
expression/SQLExpressionEvaluated.h
expression/OrderByExpressions.cc
expression/OrderByExpressions.h

expression/function/DoubleFunctions.cc
expression/function/FunctionExpression.cc
expression/function/FunctionExpression.h
expression/function/FunctionAND.cc
expression/function/FunctionAND.h
expression/function/FunctionAVG.cc
expression/function/FunctionAVG.h
expression/function/FunctionCOUNT.cc
expression/function/FunctionCOUNT.h
expression/function/FunctionDOTP.cc
expression/function/FunctionDOTP.h
expression/function/FunctionEQ.cc
expression/function/FunctionEQ.h
expression/function/FunctionRLIKE.cc
expression/function/FunctionRLIKE.h
#expression/function/FunctionMATCH.h
#expression/function/FunctionMATCH.cc
expression/function/FunctionFactory.cc
expression/function/FunctionFactory.h
expression/function/FunctionIN.cc
expression/function/FunctionIN.h
expression/function/FunctionIntegerExpression.cc
expression/function/FunctionIntegerExpression.h
expression/function/FunctionJOIN.cc
expression/function/FunctionJOIN.h
expression/function/FunctionJULIAN.cc
expression/function/FunctionJULIAN.h
expression/function/FunctionJULIAN_SECONDS.cc
expression/function/FunctionJULIAN_SECONDS.h
expression/function/FunctionMAX.cc
expression/function/FunctionMAX.h
expression/function/FunctionMIN.cc
expression/function/FunctionMIN.h
expression/function/FunctionFIRST.cc
expression/function/FunctionFIRST.h
expression/function/FunctionLAST.cc
expression/function/FunctionLAST.h
expression/function/FunctionNORM.cc
expression/function/FunctionNORM.h
expression/function/FunctionNOT_IN.cc
expression/function/FunctionNOT_IN.h
expression/function/FunctionNOT_NULL.cc
expression/function/FunctionNOT_NULL.h
expression/function/FunctionNULL.cc
expression/function/FunctionNULL.h
expression/function/FunctionNVL.cc
expression/function/FunctionNVL.h
expression/function/FunctionOR.cc
expression/function/FunctionOR.h
expression/function/FunctionRMS.cc
expression/function/FunctionRMS.h
expression/function/FunctionROWNUMBER.cc
expression/function/FunctionROWNUMBER.h
expression/function/FunctionSTDEV.cc
expression/function/FunctionSTDEV.h
expression/function/FunctionSUM.cc
expression/function/FunctionSUM.h
expression/function/FunctionTDIFF.cc
expression/function/FunctionTDIFF.h
expression/function/FunctionTHIN.cc
expression/function/FunctionTHIN.h
expression/function/FunctionTIMESTAMP.cc
expression/function/FunctionTIMESTAMP.h
expression/function/FunctionVAR.cc
expression/function/FunctionVAR.h

type/SQLBit.cc
type/SQLBit.h
type/SQLBitfield.cc
type/SQLBitfield.h
type/SQLDouble.cc
type/SQLDouble.h
type/SQLInt.cc
type/SQLInt.h
type/SQLReal.cc
type/SQLReal.h
type/SQLString.cc
type/SQLString.h
type/SQLType.cc
type/SQLType.h
)


ecbuild_generate_yy( YYPREFIX           eckit_sql_
                     YACC               sqly
                     LEX                sqll
                     FLEX_FLAGS         "-d"
                     DEPENDANT          SQLParser.cc )

if( NOT ENABLE_WARNINGS )
    # Warnings present in autogenerated files based on sqly and sqll
    list( APPEND suppress_warnings
      $<$<CXX_COMPILER_ID:GNU>:-Wno-unused-function>
      $<$<CXX_COMPILER_ID:GNU>:-Wno-sign-compare>
      $<$<CXX_COMPILER_ID:Clang>:-Wno-deprecated-register>
    )
    set_source_files_properties( SQLParser.cc PROPERTIES COMPILE_OPTIONS "${suppress_warnings}" )
endif()

ecbuild_add_library( TARGET              eckit_sql TYPE SHARED
                     INSTALL_HEADERS     ALL
                     HEADER_DESTINATION  ${INSTALL_INCLUDE_DIR}/eckit/sql
                     SOURCES             ${eckit_sql_lib_srcs}
                     TEMPLATES
                                         SQLIteratorOutput.cc
                                         expression/ShiftedColumnExpression.cc
                     LIBS                eckit )

# Disable all warnings for PGI compiler as it is overzealous and cherry-picking is not possible
target_compile_options( eckit_sql PRIVATE $<$<CXX_COMPILER_ID:PGI>:-w> )

=== src/eckit/web/CMakeLists.txt ===
list( APPEND eckit_web_srcs
AgentResource.cc
AgentResource.h
CgiResource.cc
CgiResource.h
Configure.cc
FileResource.cc
FileResource.h
FtpRequest.h
Html.cc
Html.h
HtmlObject.cc
HtmlObject.h
HtmlResource.cc
HtmlResource.h
HttpResource.cc
HttpResource.h
HttpStream.cc
HttpStream.h
HttpServer.cc
HttpServer.h
HttpService.cc
HttpService.h
HttpUser.h
JSONResource.cc
JSONResource.h
JavaAgent.cc
JavaAgent.h
JavaResource.cc
JavaResource.h
JavaServer.cc
JavaServer.h
JavaService.cc
JavaService.h
JavaUser.cc
JavaUser.h
Url.cc
Url.h)


ecbuild_add_library( TARGET eckit_web TYPE SHARED
					 INSTALL_HEADERS LISTED
					 SOURCES
						${eckit_web_srcs}
					 PERSISTENT
						HtmlObject.h
					 HEADER_DESTINATION
						${INSTALL_INCLUDE_DIR}/eckit/web
					 LIBS
						eckit )

=== debian/changelog ===
eckit (1.11.6-2) unstable; urgency=medium

  * Use debhelper 13 for variable substitution, instead of autogenerating
    dh files
  * Add d/not-installed file for files/links generated
  * Fix for latest bison upgrade. Closes: #966916

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Aug 2020 11:35:41 +0100

eckit (1.11.6-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 17 May 2020 09:41:26 +0100

eckit (1.10.1-3) unstable; urgency=medium

  *  * Runtime depend on jemalloc-dev, used by the reverse-dependencies
       Closes: #959029.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 28 Apr 2020 13:42:52 +0100

eckit (1.10.1-2) unstable; urgency=medium

  * Patch gcc10.patch needed for FTBFS (metview using JSON.h header)
  * Add initial d/tests/control to check libs working

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 20 Apr 2020 10:17:05 +0100

eckit (1.10.1-1) unstable; urgency=medium

  * New upstream release
  * Add build-dependency on librsync-dev
  * Standards-Version: 4.5.0
  * Enable JEMALLOC. Librsync suport needs > 2.0

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 18 Apr 2020 13:17:30 +0100

eckit (1.9.0-1) unstable; urgency=medium

  * New upstream release (from Metview bundle)

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 05 Apr 2020 11:18:53 +0100

=== debian/control ===
Source: eckit
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo, 
  ecbuild,
  chrpath,
  flex,
  bison,
  libopenblas-dev [ amd64 arm64 armhf i386 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  libaec-dev,
  libxxhash-dev,
  libjemalloc-dev,
  librados-dev [!hurd-i386  !kfreebsd-amd64 !kfreebsd-i386 !riscv64 !sh4 !ia64 !alpha !hppa !powerpc !mipsel] ,
  libbz2-dev,
  liblz4-dev,
  libeigen3-dev,
  libsnappy-dev,
  librsync-dev,
  mpi-default-dev,
  doxygen,
  python3-all,
  libssl-dev,
  libcurl4-gnutls-dev,
  libncurses-dev
Standards-Version: 4.5.0
Homepage: https://github.com/ecmwf/eckit
Vcs-Git: https://salsa.debian.org:/science-team/eckit.git

Package: libeckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libodb-api-dev ( << 0.18.1-8)
Replaces: libodb-api-dev ( << 0.18.1-8)
Depends: libeckit0d (= ${binary:Version}), libeckit-utils (= ${binary:Version}),
  libopenmpi-dev,
  libaec-dev,
  libssl-dev,
  libcurl4-gnutls-dev,
  libxxhash-dev,
  libjemalloc-dev,
  libsnappy-dev,
  liblz4-dev,
  libbz2-dev,
  libeigen3-dev,
  libopenblas-dev [ amd64 arm64 armhf i386 mips64el ppc64el s390x ppc64],
  libblas-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  liblapack-dev [ !amd64 !arm64 !armhf !i386 !mips64el !ppc64el !s390x !ppc64],
  ${shlibs:Depends}, ${misc:Depends}
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libodb-api-0d ( << 0.18.1-8)
Replaces: libodb-api-0d ( << 0.18.1-8)
Description: C++ toolkit for ECMWF tools and applications
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libeckit-utils
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, libeckit0d ( = ${binary:Version}),  ${shlibs:Depends}
Breaks: libodb-api-bin ( << 0.18.1-8)
Replaces: libodb-api-bin ( << 0.18.1-8)
Recommends: libeckit-dev
Description: C++ toolkit for ECMWF tools and applications - development files
 ecKit is a cross-platform c++ toolkit that supports development of tools and
 applications at ECMWF. It is based on code developed over the last 20 years
 within the MARS software and was re-factored out to be reused by other
 applications. The main focus is UNIX/POSIX systems, and it has been thoroughly
 tested on AIX, Linux and Mac OSX. Historically, the code base pre-dates and in
 some way can be seen as a leaner substitute for some 'Boost' libraries.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f


# TODO:
#   - Flang version doesn't build. 

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

BUILD_FLAGS = \
	-DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DSKIP_RPATH=On \
	-DENABLE_RSYNC=Off \
	-DENABLE_RADOS=Off \
	-DENABLE_JEMALLOC=On

%:
	dh $@ --buildsystem=cmake

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/build-*

override_dh_auto_configure:
	dh_auto_configure --  ${BUILD_FLAGS} 
	( tar axpf $(CURDIR)/../eckit_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )

override_dh_auto_test:
	@echo Tests disabled in this release

override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/lib/*.so.0d
	mkdir -p $(TMPDIR)/$(LIBDIR)/cmake/eckit
	install $(TMPDIR)/usr/lib/cmake/eckit/* $(TMPDIR)/$(LIBDIR)/cmake/eckit
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	cat $(TMPDIR)/usr/lib/cmake/eckit/eckit-import.cmake \
		| sed -e 's%/usr/bin/python %/usr/bin/python3 %g' \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-import.cmake
	cat < $(TMPDIR)/usr/lib/cmake/eckit/eckit-config.cmake \
		| sed -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  \
		| sed -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake%${LIBDIR}/cmake%g'  \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-config.cmake
	cat < $(TMPDIR)/usr/lib/cmake/eckit/eckit-targets-none.cmake \
		| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  \
		| sed -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets-none.cmake
	cat < $(TMPDIR)/usr/lib/cmake/eckit/eckit-targets.cmake \
		| sed -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  \
		| sed -e 's%$${_IMPORT_PREFIX}/lib/libeckit%${LIBDIR}/libeckit%g'  \
		| sed -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' \
		| sed -e 's%$${_IMPORT_PREFIX}/module%${MODULEDIR}%g' \
		> $(TMPDIR)/$(LIBDIR)/cmake/eckit/eckit-targets.cmake
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/eckit/*
